//BSCHDATA.CPP

#include "stdafx.h"
#include "NL.h"

#include "PartLib.h"
#include "BSchObj.h"
#include "BSchLine.h"
#include "BSchDash.h"
#include "BSchWire.h"
#include "BSchBus.h"
#include "BSchJunc.h"
#include "BSchPart.h"
#include "BSchTag.h"
#include "BSchLbl.h"
#include "BSchCmnt.h"
#include "BSchEntr.h"
#include "BSchPin.h"

#include "BSchData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




CBSchData::CBSchData()
{
	ClearAll();
}

CBSchData::~CBSchData()
{
	ClearAll();
}



//w胊Xg̃f[^
void CBSchData::ClearDataList(CPtrList* pList)
{
	POSITION pos;
	CBSchObj* pObj;
	
	pos=pList->GetHeadPosition();
	while(pos){
		pObj=(CBSchObj*)pList->GetNext(pos);
		delete pObj;
	}
	pList->RemoveAll();
}

//f[^̑S
void CBSchData::ClearAll()
{
	ClearDataList(&m_listJunction);
	ClearDataList(&m_listWire);
	ClearDataList(&m_listLabel);
	ClearDataList(&m_listTag);
	ClearDataList(&m_listPowerPart);
	ClearDataList(&m_listPart);

	//m_listPin͊ǗĂIuWFNgCBSchPinCBSchOBj
	//ĥł͂Ȃ߁AʂɏB
	POSITION pos;
	CBSchPin* pObj;
	
	pos=m_listPin.GetHeadPosition();
	while(pos){
		pObj=(CBSchPin*)m_listPin.GetNext(pos);
		delete pObj;
	}
	m_listPin.RemoveAll();
}

#pragma pack(1)		//\̂̋EPoCgPʂɕύX

//CE 2.xT|[g"CE DATA FILE $0001\x1a"ƌ݊̂wb_[
static struct 
{
	BYTE	byteRes;		// 0x20 (==Space   )
	char	szId[32];		// "CE DATA FILE $0001\x1a" 
	BYTE	byteSize;		// }ʃTCY0`4B0xFF̂Ƃ̓Nbv{[hB
	short int left;			// byteSize0xFF̂ƂɗLBshort int 2oCgz
	short int top;			//                          
	short int right;		//                          
	short int bottom;		//                          
	WORD	wShowLayer;		// \C[
	WORD	nEditLayer;		// ҏWC[
	char	reserved[13];	// \
}CE0001FileHeader;

#pragma pack()		//\̂̋EftHgɖ߂

static char szCE0001FHId[]="CE DATA FILE $0001\x1a";


	
//t@C̓ǂݍ
// I				CBSchData::noerror
// I[vG[		CBSchData::openerror
// f[^G[			CBSchData::dataerror
// CuƂ̕s	CBSchData::libraryerror
int CBSchData::ReadData(LPCSTR pszFileName)
{
//	CObList* pList;
	BYTE byteId;
	BYTE arraybyte[64];
	CBSchObj* pObj;

	CPoint ptOffset=CPoint(0,0);

	//BOOL bNewData;		//VKǂݍ:TRUE  ǉǂݍ:FALSE

	//f[^̑S
	ClearAll();

	CFile file;
	if(!file.Open(pszFileName,CFile::modeRead)) return CBSchData::openerror;

	//t@Cwb_[̓ǂݍ݂ID̊mF
	if(	file.Read(&byteId,1)!=1 ||
		file.Read(&CE0001FileHeader,sizeof(CE0001FileHeader))!=sizeof(CE0001FileHeader))
		return CBSchData::dataerror;
	if(byteId!=CE2_FILEHEADER) return CBSchData::dataerror;
	if(lstrcmp(CE0001FileHeader.szId,szCE0001FHId)) return CBSchData::dataerror;


	//}ʃIuWFNg̓ǂݍ
	while(1){
		if(file.Read(&byteId,1)!=1) break;//t@CGhŃ[vEo
		switch(byteId){
		case CE2_FILEHEADER://Qڂ̃t@Cwb_[ȍ~ŃItZbgB
			if(file.Read(arraybyte,sizeof(CE0001FileHeader))!=sizeof(CE0001FileHeader)) return CBSchData::dataerror;
			ptOffset.y+=5000;
			break;
		case CE2_JUNC:
			if((pObj=(CBSchObj*)new CBSchJunc)==NULL) return CBSchData::dataerror;
			if(pObj->ReadCE2(&file,byteId,&ptOffset)==FALSE) return CBSchData::dataerror;
			m_listJunction.AddTail((void*)pObj);
			break;
		case CE2_ENTRY://lbgXgł͈ӖȂBǂ݁B
			if((pObj=(CBSchObj*)new CBSchEntry)==NULL) return CBSchData::dataerror;
			if(pObj->ReadCE2(&file,byteId)==FALSE) return CBSchData::dataerror;
			delete pObj;
			break;
		case CE2_WIRE:
			if((pObj=(CBSchObj*)new CBSchWire)==NULL) return CBSchData::dataerror;
			if(pObj->ReadCE2(&file,byteId,&ptOffset)==FALSE) return CBSchData::dataerror;
			//((CBSchWire*)pObj)->m_listName.AddTail("NAME");
			m_listWire.AddTail((void*)pObj);
			break;
		case CE2_BUS://lbgXgł͈ӖȂBǂ݁B
			if((pObj=(CBSchObj*)new CBSchBus)==NULL) return CBSchData::dataerror;
			if(pObj->ReadCE2(&file,byteId)==FALSE) return CBSchData::dataerror;
			delete pObj;
			break;
		case CE2_DASH://lbgXgł͈ӖȂBǂ݁B
			if((pObj=(CBSchObj*)new CBSchDash)==NULL) return CBSchData::dataerror;
			if(pObj->ReadCE2(&file,byteId)==FALSE) return CBSchData::dataerror;
			delete pObj;
			break;
		case CE2_TAG:
			if((pObj=(CBSchObj*)new CBSchTag)==NULL) return CBSchData::dataerror;
			if(pObj->ReadCE2(&file,byteId,&ptOffset)==FALSE) return CBSchData::dataerror;
			m_listTag.AddTail((void*)pObj);
			break;
		case CE2_LABEL:
			if((pObj=(CBSchObj*)new CBSchLabel)==NULL) return CBSchData::dataerror;
			if(pObj->ReadCE2(&file,byteId,&ptOffset)==FALSE) return CBSchData::dataerror;
			m_listLabel.AddTail((void*)pObj);
			break;
		case CE2_COMMENT://lbgXgł͈ӖȂBǂ݁B
			if((pObj=(CBSchObj*)new CBSchComment)==NULL) return CBSchData::dataerror;
			if(pObj->ReadCE2(&file,byteId)==FALSE) return CBSchData::dataerror;
			delete pObj;
			break;
		case CE2_PART:
			if((pObj=(CBSchObj*)new CBSchPart)==NULL) return CBSchData::dataerror;
			if(pObj->ReadCE2(&file,byteId,&ptOffset)==FALSE) return CBSchData::dataerror;
			if(pObj->GetStus() & STUS_DELETE){
				delete pObj;//CBSchPart.ReadCE2()ŃCuݒɎs STUS_DELETE 
				TRACE("\nError in setting part-index");
				return CBSchData::libraryerror;
			}else {
				//LPCSTR pszName=((CBSchPart*)pObj)->GetPartIndex()->GetName(NULL);
				////TRACE("Default part name - %s\n",pszName);
				//if(g_IsPowerPart(pszName)){
				////if(    lstrcmp(pszName,"VCC")==0
				////	|| lstrcmp(pszName,"VDD")==0
				////	|| lstrcmp(pszName,"GND")==0
				////	|| lstrcmp(pszName,"VEE")==0
				////	|| lstrcmp(pszName,"VSS")==0){
				if(g_IsPowerPart((CBSchPart*)pObj)){
					//TRACE("Add Power Part %s\n",pszName);
					m_listPowerPart.AddTail((void*)pObj);
				}else{
					m_listPart.AddTail((void*)pObj);
				}
			}
			break;
		default:
			TRACE("\nNot supported data type.(CBSchDoc::ReadCE2())");
			return CBSchData::dataerror;
		}
	}
	return CBSchData::noerror;
}


#ifdef _DEBUG
//fobOpf[^
int CBSchData::WriteData(LPCSTR pszSrcFile)
{
	char szNetSchFileName[_MAX_PATH];

	char szDrive[_MAX_DRIVE];
	char szDir[_MAX_DIR];
	_splitpath(pszSrcFile,szDrive,szDir,NULL,NULL);
	_makepath(szNetSchFileName,szDrive,szDir,"NET",".CE2");

	
	CFile file;
	if(!file.Open(szNetSchFileName,CFile::modeWrite|CFile::modeCreate)) 
		return CBSchData::openerror;

	
	BYTE byte=CE2_FILEHEADER;	//t@Cwb_[\̂ID̐ݒ
	file.Write(&byte,1);			//t@Cwb_[\̂ID̏
	CE0001FileHeader.byteRes=0x20;
	lstrcpy(CE0001FileHeader.szId,szCE0001FHId);

	CE0001FileHeader.byteSize=4;
	CE0001FileHeader.left  = CE0001FileHeader.top=
		CE0001FileHeader.right = CE0001FileHeader.bottom=0;
	CE0001FileHeader.wShowLayer=0xff;
	CE0001FileHeader.nEditLayer=0;

	file.Write(&CE0001FileHeader,sizeof(CE0001FileHeader));	//t@Cwb_[\̂̏
	ListWriteCE2(&m_listJunction,&file);
	ListWriteCE2(&m_listWire,&file);
	ListWriteCE2(&m_listLabel,&file);
	ListWriteCE2(&m_listTag,&file);
	ListWriteCE2(&m_listPowerPart,&file);
	ListWriteCE2(&m_listPart,&file);
	TRACE("End of CBSchData::WriteCE2()\n");
	return 0;
}

BOOL CBSchData::ListWriteCE2(CPtrList* pList,CFile* pf)
{
	CBSchObj* pObj;
	POSITION pos=pList->GetHeadPosition();			//Xg̐擪̗vf𓾂
	while(pos){
		pObj=(CBSchObj*)pList->GetNext(pos);		//vf̃|C^𓾂
		if(pObj->GetStus() & STUS_DELETE) continue;	//f[^Ȃ牽Ȃ
		if(!pObj->WriteCE2(pf))return FALSE;//vf̃t@Cւ̏
	}
	return TRUE;
}

#endif



